-module(glychee@benchmark).
-compile(no_auto_import).

-export([run/2]).
-export_type([function_/2, data/1]).

-type function_(EVA, EVB) :: {function, binary(), fun((EVA) -> EVB)}.

-type data(EVC) :: {data, binary(), EVC}.

-spec run(list(function_(EVD, any())), list(data(EVD))) -> nil.
run(Function_sets, Data_sets) ->
    gleam@list:each(
        Data_sets,
        fun(Data_set) ->
            gleam@io:print(<<"\n\n"/utf8>>),
            gleam@io:println(gleam@string:repeat(<<"="/utf8>>, 80)),
            gleam@io:println(
                begin
                    _pipe = <<<<"== data set: "/utf8,
                                (erlang:element(2, Data_set))/binary>>/binary,
                              " "/utf8>>,
                    gleam@string:pad_right(_pipe, 80, <<"="/utf8>>)
                end
            ),
            gleam@io:println(gleam@string:repeat(<<"="/utf8>>, 80)),
            gleam@io:print(<<"\n"/utf8>>),
            _pipe@1 = Function_sets,
            _pipe@2 = gleam@list:map(
                _pipe@1,
                fun(Function_set) ->
                    {erlang:element(2, Function_set),
                     (erlang:element(3, Function_set))(
                         erlang:element(3, Data_set)
                     )}
                end
            ),
            'Elixir.GlycheeBenchee':run(_pipe@2)
        end
    ).
