-module(glychee_example_benchmark_module).
-compile(no_auto_import).

-export([main/0]).

-spec main() -> nil.
main() ->
    glychee@benchmark:run(
        [{function,
          <<"list.sort()"/utf8>>,
          fun(Test_data) ->
              fun() -> gleam@list:sort(Test_data, fun gleam@int:compare/2) end
          end},
         {function,
          <<"erlang:lists:sort()"/utf8>>,
          fun(Test_data@1) -> fun() -> lists:sort(Test_data@1) end end}],
        [{data, <<"pre-sorted list"/utf8>>, gleam@list:range(1, 100000)},
         {data,
          <<"reversed list"/utf8>>,
          begin
              _pipe = gleam@list:range(1, 100000),
              gleam@list:reverse(_pipe)
          end},
         {data,
          <<"shuffled list"/utf8>>,
          begin
              _pipe@1 = gleam@list:range(1, 100000),
              'Elixir.Enum':shuffle(_pipe@1)
          end}]
    ).
